from kivy.uix.widget import Widget
from kivy.uix.scrollview import ScrollView
from kivy.uix.floatlayout import FloatLayout

from kivy.graphics import Rectangle

from kivy.core.image import ImageLoader
from kivy.cache import Cache
from kivy.app import App


imageloader = ImageLoader()
Cache.register('ctpug', limit=200)

def _load(filename):
    obj = Cache.get('ctpug', filename)
    if obj is None:
        obj = imageloader.load(filename)
        Cache.append('ctpug', filename, obj)
    return obj.texture

class MyWidget(Widget):

    def __init__(self, filename, pos):
        super(MyWidget, self).__init__()
        self.size = (1000, 300)
        self.size_hint = (None, None)
        self.pos = pos
        self._texture = _load(filename)
        with self.canvas:
            self.rect =  Rectangle(pos=self.pos, size=(1000, 1000), texture=self._texture)
        self.bind(pos=self.redraw)

    def redraw(self, inst, val):
        print self.pos
        self.rect.pos = self.pos


class MyApp(App):

    def build(self):
        root = ScrollView(size=(400, 400))
        layout = FloatLayout(size=(1000, 900), size_hint=(None, None))
        layout.add_widget(MyWidget('cwall.png', (0, 0)))
        layout.add_widget(MyWidget('floor.png', (0, 300)))
        layout.add_widget(MyWidget('cwall.png', (0, 600)))
        root.add_widget(layout)
        return root

if __name__ == "__main__":
    MyApp().run()
        
